<script lang="ts">
  import Fa from 'svelte-fa';
  import { faChevronDown, faX } from '@fortawesome/free-solid-svg-icons';
  import { createEventDispatcher } from 'svelte';
  import { clickOutside } from '$lib/directives/click-outside';

  export let title: string;
  export let options: string[];
  export let selectedOptions: string[] = [];
  export let multiple = false;
  export let open = false;
  export { clazz as class };

  let clazz = '';
  let lastSelection: string[] = [];
  const dispatch = createEventDispatcher();

  function handleClick(selection: string | null) {
    if (selection === null) {
      // clear the selection
      selectedOptions = [];
      open = false;
      return;
    }
    if (selectedOptions.includes(selection)) {
      // remove selection
      selectedOptions = selectedOptions.filter((s) => s != selection);
    } else {
      // add selection
      if (multiple) {
        // re-assign to trigger UI update
        selectedOptions = [...selectedOptions, selection];
      } else {
        selectedOptions = [selection];
        // close dropdown, since nothing else can be selected now
        open = false;
      }
    }
  }

  function triggerSelection() {
    // if there hasn't been a change, don't trigger a select event
    if (selectedOptions.length === lastSelection.length && selectedOptions.every((a, i) => lastSelection[i] === a)) {
      return;
    }
    lastSelection = selectedOptions;

    if (multiple) dispatch('select', selectedOptions);
    else if (selectedOptions.length > 0) dispatch('select', selectedOptions[0]);
    else dispatch('select', null);
  }

  // trigger selection only when modal is closed
  $: if (!open) triggerSelection();
</script>

<div class="relative inline-block text-left z-100 {clazz}">
  <!-- Plain div is needed for absolute positioning -->
  <div>
    <button
      type="button"
      class="inline-flex w-full justify-center rounded-md border border-gray-300 bg-white px-4 py-2 text-sm font-medium text-gray-700 shadow-sm hover:bg-gray-50 focus:outline-none focus:ring-2 focus:ring-indigo-500 focus:ring-offset-2 focus:ring-offset-gray-100"
      aria-expanded="true"
      aria-haspopup="true"
      on:click={() => (open = !open)}>
      {#if multiple && selectedOptions.length > 0}
        <!-- Display title and number of selections -->
        {title}
        ({selectedOptions.length})
      {:else if !multiple && selectedOptions.length > 0}
        <!-- Display single selection -->
        {selectedOptions[0]}
      {:else}
        <!-- Nothing selected, display title -->
        {title}
      {/if}

      <Fa class="pl-2 mt-0.5" icon={faChevronDown} />
    </button>
  </div>

  <!-- todo reimplement use:clickOutside on:click_outside={() => (open = false)} -->
  <div
    class="absolute mt-2 origin-top-right rounded-md bg-white shadow-lg ring-1 ring-black ring-opacity-5 focus:outline-none"
    class:hidden={!open}
    role="menu"
    aria-orientation="vertical"
    aria-labelledby="menu-button"
    tabindex="-1">
    <div class="py-1" role="none">
      <a
        class="block px-4 py-2 text-sm cursor-pointer text-gray-700 font-extrabold italic"
        role="menuitem"
        tabindex="-1"
        on:click={() => handleClick(null)}>
        --
      </a>
      {#each options as option}
        <a
          class="block px-4 py-2 text-sm cursor-pointer
                 {selectedOptions.includes(option) ? 'bg-gray-300 text-gray-900' : 'text-gray-700'}"
          role="menuitem"
          tabindex="-1"
          on:click={() => handleClick(option)}>
          {option}
        </a>
      {/each}
    </div>
  </div>
</div>
